from modes.mlxburn_mode import I_MlxburnMode
from modes.mlxburn_ImageGenerateMode import ImageGenerateMode
from mlxburn_utils import *


class ViewVersionMode(I_MlxburnMode):
    def execute(self):
        if self._args.mst_dev:
            fw_version = self._from_device()
        else:
            try:
                fw_file_version_viewer = ImageGenerateMode(self._args, mode=MAIN_MODE.SHOW_FW_VER)
                fw_version = fw_file_version_viewer.get_fwver_fw_file()
            except Exception():
                raise
            finally:
                del fw_file_version_viewer
        logging.info("FW Version: {}".format((fw_version)))

    def _from_device(self):
        query_map = query(self._args.mst_dev)
        return query_map["FW_Version"]
